"use strict";

exports.__esModule = true;
exports.withTailwindOverload = exports.overloadTailwind = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _removeMatchingPlugins = require("./removeMatchingPlugins");

var _removeMatchingPlugins2 = _interopRequireDefault(_removeMatchingPlugins);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var overloadTailwind = exports.overloadTailwind = function overloadTailwind(initialClasses, overloadClasses) {
  if (!overloadClasses) {
    return initialClasses;
  }

  var removed = (0, _removeMatchingPlugins2.default)(initialClasses, overloadClasses);

  return (removed + " " + overloadClasses).trim();
};

var withTailwindOverload = function withTailwindOverload(PassedComponent) {
  return function (_ref) {
    var className = _ref.className,
        rest = _objectWithoutProperties(_ref, ["className"]);

    var overloadedClasses = overloadTailwind(PassedComponent.defaultClassNames, className);
    return _react2.default.createElement(PassedComponent, _extends({}, rest, { className: overloadedClasses }));
  };
};
exports.withTailwindOverload = withTailwindOverload;